



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>AJAX跨域问题总结</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">AJAX跨域问题总结</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-10 01:11:44 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h3>跨域是什么？</h3>
<p>首先说下同源，同源策略是浏览器的一种安全策略，所谓同源是指，域名，协议，端口完全相同。而跨域就是不同源 !</p>
<h3>能够进行跨域的请求</h3>
<p>一般a,img,link[rel=stylesheet]，video,audio,等等能够发出请求的标签都可以实现跨域访问。但是这些标签不能得到返回的东西，所以一般不会用他们来请求资源。</p>
<h3>常见的跨域处理方案：</h3>
<p>由于ajax先天设计的时候，不能实现跨域访问。所以就出现了处理跨域这样的问题。&nbsp;<br />① jsonp来处理跨域，下面用<a href="http://lib.csdn.net/base/jquery" rel="external nofollow noreferrer">jQuery</a>来实现，关键代码如下：</p>
<pre class="prettyprint linenums"><code>$.ajax({<br />
  type : "GET",<br />
  url : "http://www.a.com/index.php?message=msg&amp;callback=?",<br />
  dataType : "jsonp",<br />
  jsonp: 'callback',<br />
  success : function(json){<br />
      console.log(json.msg);<br />
  }<br />
});</code></pre>
<p>② 服务端设置 Access-Control-Allow-Origin&nbsp;<br />我们使用nodejs来完成这一问题。服务端代码如下：</p>
<pre class="prettyprint linenums"><code>"use strict"<br />
const http = require('http');<br />
const server = http.createServer();

server.on('request',(req,res)=&gt;{<br />
    res.writeHead(200,{"Content-Type":"text/plain","Access-Control-Allow-Origin":"*"});<br />
    res.write('ajax cross domain');<br />
    res.end();<br />
})

server.listen(3000,(err)=&gt;{<br />
  if(err){<br />
    return console.log(err.message);<br />
  }<br />
  console.log('server is on');<br />
})</code></pre>
<p>浏览器端代码如下：</p>
<pre class="prettyprint linenums"><code>window.onload = function(){<br />
  var xhr = new XMLHttpRequest();<br />
  xhr.open("post","http://localhost:3000/");<br />
  xhr.onreadystatechange=function(){<br />
    if(xhr.readyState==4){<br />
        if(xhr.status==200){<br />
          console.log(xhr.responseText);<br />
        }<br />
    }<br />
  }<br />
  xhr.send(null);<br />
}</code></pre>
<p>使用http的形式访问客户端网页，那么就会输出不同源下返回的数据。&nbsp;<br />③ 其他跨域策略 iframe, window.postMessage()等&nbsp;<br />详见：&nbsp;<a href="http://rickgray.me/2015/09/03/solutions-to-cross-domain-in-browser.html" rel="external nofollow noreferrer">http://rickgray.me/2015/09/03/solutions-to-cross-domain-in-browser.html</a></p>
<p>④ 使用豆瓣的api，简单封装一个跨域请求函数：</p>
<pre class="prettyprint linenums"><code>&lt;script&gt;<br />
    /* 封装数据  跨域url  params fn */<br />
    function crossDomain(url,params,fn){<br />
        var head = document.getElementsByTagName('head')[0];<br />
        // 1. 处理回调函数<br />
        var cbName = 'jsonp'+ (Math.random() * Math.random()).toString().substr(2) + new Date().getTime();<br />
        /* 将回调函数挂载到window对象上 */<br />
        window[cbName] = function(data){<br />
            // 拿到并处理数据<br />
            fn(data);<br />
            // 拿到数据后remove掉<br />
            //head.removeChild(scriptObj);<br />
        }<br />
        // 2. 解析url<br />
        var qstring = '';<br />
        for(var key in params){<br />
            qstring += key + '=' + params['key'] + '&amp;';<br />
        }<br />
        qstring += 'callback=' + cbName;<br />
        url += '?' + qstring;<br />
        // 3. 插入script<br />
        var scriptObj = document.createElement('script');<br />
        scriptObj.src = url;<br />
        head.appendChild(scriptObj);<br />
    }<br />
&lt;/script&gt;

&lt;script&gt;<br />
    /*  使用  */<br />
    crossDomain('http://api.douban.com/v2/movie/in_theaters',{},function(data){<br />
        console.log(data);<br />
    })<br />
&lt;/script&gt;</code></pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/p39rgm80.html">关于&period;NET异常处理的思考</a>
		</li>
						<li><a href="https://www.batexi.com/a/49ger708.html">Mipmap与纹理过滤</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8ej6mj9.html">Linux-TCP Queue的一些问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/49godgeq.html">由SimpleAyncTaskExecutor到ListenableFutureTask</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kxvk3q.html">Python关键字参数</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvxv018.html">C&num;中的volatile用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlz21x8.html">ArcGIS API for Silverlight 加载google地图</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j00relq.html">robot API笔记6</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnonvz8.html">EIG集团简单介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok32le9.html">C&plus;&plus; 的隱式型別轉換</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd3lmdq.html">Android4&period;0的Alertdialog对话框，设置点击其他位置不消失</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1wvp69.html">（Qt 翻译） QGLSceneNode</a>
		</li>
						<li><a href="https://www.batexi.com/a/950p54v8.html">PAT &lpar;Advanced Level&rpar; 1040&period; Longest Symmetric String &lpar;25&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yn0rw8.html">第二章   Oracle数据库应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1pr0oq.html">TensorFlow问题&OpenCurlyDoubleQuote;The TensorFlow library wasn&amp;&num;39&semi;t compiled to use SSE instructions&comma; but these are available on your machine and could speed up CPU computations&period;&rdquo;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj031j9.html">&lbrack;py&rsqb;Win10下的pip&sol;pip3 install 导致utf-8编码问题的解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwjewk8.html">IOS越狱插件汉化工具</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvv2rk8.html">Openvswitch手册&lpar;8&rpar;&colon; ovs-vsctl的DB的操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwjknz9.html">c&sol;c&plus;&plus; 标准库 智能指针&lpar; smart pointer &rpar; 是啥玩意儿</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gm6nmq.html">&lbrack;Docker&rsqb;如何批量删除镜像</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8zoxdpxq.html">Eclipse远程调试应用程序</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kp4w239.html">BZOJ 1299&colon; &lbrack;LLH邀请赛&rsqb;巧克力棒 &lbrack;组合游戏&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mezo7oq.html">XGoServer  一个基础性、模块完整且安全可靠的服务端框架</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zo2gx3q.html">&amp;quot&semi;abc123 &comma;def456&amp;quot&semi;，反转字母，其他位置不变</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1knzmz9.html">修改Request 中的数据</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pkoyy8.html">java程序设计原则</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjk1yk8.html">java生产者与消费者模式</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj2mv69.html">yii2 源码分析Behavior类分析 （四）</a>
			</li>
						<li><a href="https://www.batexi.com/a/90mnmon8.html">【echarts3】--1 简单入门</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4z2jyn9.html">CENTOS6&period;6下zabbix2&period;4&period;7搭建</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
